org.eclipse.viatra.query.runtime.localsearch.planner.cost.impl

## Class HybridMatcherConstraintCostFunction

- java.lang.Object
- - org.eclipse.viatra.query.runtime.localsearch.planner.cost.impl.StatisticsBasedConstraintCostFunction
  - - org.eclipse.viatra.query.runtime.localsearch.planner.cost.impl.IndexerBasedConstraintCostFunction
    - - org.eclipse.viatra.query.runtime.localsearch.planner.cost.impl.HybridMatcherConstraintCostFunction

- All Implemented Interfaces:
    ICostFunction

      public class HybridMatcherConstraintCostFunction
      extends IndexerBasedConstraintCostFunction

  This cost function is intended to be used on hybrid configuration, with the strict restriction than any non-flattened positive pattern call is executed with Rete engine. This implementation provides the exact number of matches by invoking the result provider for the called pattern.

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.localsearch.planner.cost.impl.StatisticsBasedConstraintCostFunction

      `DEFAULT_COST, MAX_COST`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HybridMatcherConstraintCostFunction()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected double` | `_calculateCost(PositivePatternCall patternCall, IConstraintEvaluationContext input)`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.localsearch.planner.cost.impl.IndexerBasedConstraintCostFunction

      `countTuples`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.localsearch.planner.cost.impl.StatisticsBasedConstraintCostFunction

      `_calculateCost, _calculateCost, _calculateCost, _calculateCost, _calculateCost, apply, calculateBinaryExtendCost, calculateCost, calculateUnaryConstraintCost`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### HybridMatcherConstraintCostFunction

          public HybridMatcherConstraintCostFunction()

  - ### Method Detail

    - #### _calculateCost

          protected double _calculateCost(PositivePatternCall patternCall,
                                          IConstraintEvaluationContext input)

      Overrides:
        `_calculateCost` in class `StatisticsBasedConstraintCostFunction`